Sub Main()
     print "Starting Family Photos"

     m.imageSizeX = 1280
     m.imageSizeY = 720
     m.index = 0

     port = CreateObject("roMessagePort")
     m.screen = CreateObject("roImageCanvas")
     m.screen.SetMessagePort(port)
     ' m.screen.SetRequireAllImagesToDraw(true)

     m.arrayImages = [ 
          { url:"pkg:/images/Slide01.jpg",
            TargetRect:{x:0,y:0,w:1280,h:720 }
          },
          { url:"pkg:/images/Slide02.jpg", 
            TargetRect:{x:0,y:0,w:1280,h:720 }
          },
          { url:"pkg:/images/Slide03.jpg",
            TargetRect:{x:0,y:0,w:1280,h:720 }
          }
     ]
     m.slideCount = m.arrayImages.Count()

     m.screen.SetLayer(0, {Color:"#FF000040", CompositionMode:"Source"})
     m.screen.SetLayer(2, m.arrayImages[m.index])
     m.screen.Show()

     ChangeSlide()

     While(True)

         msg = wait(0, port) 
         If type(msg) = "roImageCanvasEvent" and msg.isRemoteKeyPressed() Then
               button = msg.GetIndex()
               print "button is "; button

               If ((button = 5) Or (button = 6)) and m.index < m.slideCount - 1 Then
                    print "Show Next Slide"
                    m.index = m.index + 1
                    ChangeSlide()
               Else If (button = 4) And (m.index > 0)  Then
                    print "Show Previous Slide"
                    m.index = m.index - 1
                    ChangeSlide()
               Else If (button = 10) Then ' Info button
                    DisplayDialog()
               End If
          End If

     End While

End Sub


Function DisplayDialog()
     dialog = CreateObject("roPinEntryDialog")
     dialog.SetMessagePort(CreateObject("roMessagePort"))
     dialog.EnableOverlay(true)
     dialog.EnableBackButton(true)
     dialog.SetNumPinEntryFields(4)
     dialog.SetTitle("Enter your Roku PIN to begin your free trial.")
     dialog.AddButton(1, "Continue")
     dialog.AddButton(99, "Back")
     dialog.Show()
     While True
          msg = wait(0, dialog.GetMessagePort())
          If msg <> invalid
               print "msg is "; msg
               if msg.isScreenClosed()
                    print "msg is isScreenClosed"; msg
                    exit while
               Else If msg.isButtonPressed()
                    print "the index of the button pressed is"; msg.GetIndex()
                    If msg.GetIndex() = 1 Then
                         print "The user entereded PIN "; dialog.Pin()
                    Else If msg.GetIndex() = 99 Then
                         print "The user cancelled."
                    Endif
                    exit while
               End If
          End If
     End While
     print "Just before dialog.Close"
     dialog.Close()
End Function


Function ChangeSlide()

''     If m.index < 0 Then
''          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
''     Else If m.index >= m.slideCount Then
''          m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
''     Else
''          m.nextBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
''     End If

     m.screen.ClearLayer(1)
     m.screen.SetLayer(1, m.arrayImages[m.index])
     m.screen.SwapLayers(1,2)

''     m.nextBitmap.SetAlphaEnable(true)
''
''     For i = 0 to 255 Step 5
''          hexcolor = &hFFFFFFFF - i
''          hexcolor2  = &hFFFFFF00 + i
''
''          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap, hexcolor) 'fadeout
''          m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.nextBitmap, hexcolor2) 'fadein
''
''          m.screen.SwapBuffers()
''     End For

     m.screen.ClearLayer(1)

End Function

